/*addHook("ThinkFrame", do
	for player in players.iterate
		if (player.mo.valid) and (player.mo.skin == "miles")
			if player.speed >= 28*FRACUNIT
			and (player.cmd.buttons & BT_SPIN)
			and not P_IsObjectOnGround(player.mo)
				player.panim = PA_RUN
				player.mo.state = S_PLAY_RUN
				player.mo.momz = abs($)>FRACUNIT and $*4/5 or 0
				if player.speed >= 50*FRACUNIT
					P_Thrust(player.mo,player.mo.angle,FRACUNIT/21)
				local ghost = P_SpawnGhostMobj(player.mo)
					ghost.color = player.mo.color
					ghost.colorized = true
					ghost.fuse = 3
					ghost.blendmode = AST_ADD
					ghost.destscale = 12*FRACUNIT/10
				else
					P_Thrust(player.mo,player.mo.angle,FRACUNIT/13)
				end
				local ghost = P_SpawnGhostMobj(player.mo)
				ghost.color = player.mo.color
				ghost.colorized = true
				ghost.fuse = 2
				ghost.blendmode = AST_ADD
				ghost.destscale = 11*FRACUNIT/10
			end
		end
	end
end)*/

sfxinfo[sfx_drill2] = {
	singular = false,
	caption = "Boosting"
}
sfxinfo[sfx_spdpad] = {
	singular = false,
	caption = "Forward"
}

sfxinfo[sfx_zoom] = {
	singular = false,
	caption = "Upward"
}
addHook("PlayerThink", function(player)
	if (player.mo.valid) and (player.mo.skin == "sawtooth")
	and (player.cmd.buttons & BT_CUSTOM1)
	and (player.powers[pw_tailsfly] > 5*TICRATE)
		player.powers[pw_tailsfly] = 5*TICRATE
		S_StartSound(player.mo, sfx_spdpad)
		S_StartSound(player.mo, sfx_drill2)
	local ghost = P_SpawnGhostMobj(player.mo)
		ghost.color = ColorOpposite(player.mo.color)
		ghost.colorized = true
		ghost.fuse = 15
		ghost.scale = player.mo.scale*3/2
		ghost.tracer.color = ColorOpposite(player.mo.color)
		ghost.tracer.colorized = true
		ghost.tracer.fuse = 15
		ghost.tracer.scale = player.mo.scale*3/2
		P_Thrust(player.mo, player.mo.angle, 24*FRACUNIT, true)
	end
end)

addHook("PlayerThink", function(player)
	if (player.mo.valid) and (player.mo.skin == "sawtooth")
	and (player.cmd.buttons & BT_CUSTOM1)
	and (player.powers[pw_tailsfly] < 4*TICRATE)
	and (player.powers[pw_tailsfly] > 2*TICRATE)
	and not (P_IsObjectOnGround(player.mo))
		player.powers[pw_tailsfly] = 2*TICRATE
		S_StartSound(player.mo, sfx_spdpad)
		S_StartSound(player.mo, sfx_drill2)
	local ghost = P_SpawnGhostMobj(player.mo)
		ghost.color = ColorOpposite(player.mo.color)
		ghost.colorized = true
		ghost.fuse = 15
		ghost.scale = player.mo.scale*3/2
		ghost.tracer.color = ColorOpposite(player.mo.color)
		ghost.tracer.colorized = true
		ghost.tracer.fuse = 15
		ghost.tracer.scale = player.mo.scale*3/2
		P_Thrust(player.mo, player.mo.angle, 16*FRACUNIT, true)
	end
end)

//upward flight?
addHook("PlayerThink", function(player)
	if (player.mo.valid) and (player.mo.skin == "sawtooth")
	and (player.cmd.buttons & BT_CUSTOM2)
	and (player.powers[pw_tailsfly] > 5*TICRATE)
		player.powers[pw_tailsfly] = 5*TICRATE
		S_StartSound(player.mo, sfx_zoom)
		S_StartSound(player.mo, sfx_drill2)
	local ghost = P_SpawnGhostMobj(player.mo)
		ghost.color = ColorOpposite(player.mo.color)
		ghost.colorized = true
		ghost.fuse = 15
		ghost.scale = player.mo.scale*3/2
		ghost.tracer.color = ColorOpposite(player.mo.color)
		ghost.tracer.colorized = true
		ghost.tracer.fuse = 15
		ghost.tracer.scale = player.mo.scale*3/2
		local a = P_SpawnMobj(player.mo.x - 12*FRACUNIT, player.mo.y, player.mo.z, MT_SPINDUST)
		local b = P_SpawnMobj(player.mo.x + 12*FRACUNIT, player.mo.y, player.mo.z, MT_SPINDUST)
		local c = P_SpawnMobj(player.mo.x, player.mo.y - 12*FRACUNIT, player.mo.z, MT_SPINDUST)
		local d = P_SpawnMobj(player.mo.x, player.mo.y + 12*FRACUNIT, player.mo.z, MT_SPINDUST)
		local e = P_SpawnMobj(player.mo.x - 12*FRACUNIT, player.mo.y - 12*FRACUNIT, player.mo.z, MT_SPINDUST)
		local f = P_SpawnMobj(player.mo.x + 12*FRACUNIT, player.mo.y - 12*FRACUNIT, player.mo.z, MT_SPINDUST)
		local g = P_SpawnMobj(player.mo.x - 12*FRACUNIT, player.mo.y + 12*FRACUNIT, player.mo.z, MT_SPINDUST)
		local h = P_SpawnMobj(player.mo.x + 12*FRACUNIT, player.mo.y + 12*FRACUNIT, player.mo.z, MT_SPINDUST)
		P_InstaThrust(a, player.mo.angle, player.speed)
		P_InstaThrust(b, player.mo.angle, player.speed)
		P_InstaThrust(c, player.mo.angle, player.speed)
		P_InstaThrust(d, player.mo.angle, player.speed)
		P_InstaThrust(e, player.mo.angle, player.speed)
		P_InstaThrust(f, player.mo.angle, player.speed)
		P_InstaThrust(g, player.mo.angle, player.speed)
		P_InstaThrust(h, player.mo.angle, player.speed)
		//P_Thrust(player.mo, player.mo.angle, 41*FRACUNIT, true)
		P_SetObjectMomZ(player.mo, 12*FRACUNIT, true)
	end
end)

addHook("PlayerThink", function(player)
	if (player.mo.valid) and (player.mo.skin == "sawtooth")
	and (player.cmd.buttons & BT_CUSTOM2)
	and (player.powers[pw_tailsfly] < 4*TICRATE)
	and (player.powers[pw_tailsfly] > 2*TICRATE)
	and not (P_IsObjectOnGround(player.mo))
		player.powers[pw_tailsfly] = 2*TICRATE
		S_StartSound(player.mo, sfx_zoom)
		S_StartSound(player.mo, sfx_drill2)
	local ghost = P_SpawnGhostMobj(player.mo)
		ghost.color = ColorOpposite(player.mo.color)
		ghost.colorized = true
		ghost.fuse = 15
		ghost.scale = player.mo.scale*3/2
		ghost.tracer.color = ColorOpposite(player.mo.color)
		ghost.tracer.colorized = true
		ghost.tracer.fuse = 15
		ghost.tracer.scale = player.mo.scale*3/2
		local a = P_SpawnMobj(player.mo.x - 12*FRACUNIT, player.mo.y, player.mo.z, MT_SPINDUST)
		local b = P_SpawnMobj(player.mo.x + 12*FRACUNIT, player.mo.y, player.mo.z, MT_SPINDUST)
		local c = P_SpawnMobj(player.mo.x, player.mo.y - 12*FRACUNIT, player.mo.z, MT_SPINDUST)
		local d = P_SpawnMobj(player.mo.x, player.mo.y + 12*FRACUNIT, player.mo.z, MT_SPINDUST)
		local e = P_SpawnMobj(player.mo.x - 12*FRACUNIT, player.mo.y - 12*FRACUNIT, player.mo.z, MT_SPINDUST)
		local f = P_SpawnMobj(player.mo.x + 12*FRACUNIT, player.mo.y - 12*FRACUNIT, player.mo.z, MT_SPINDUST)
		local g = P_SpawnMobj(player.mo.x - 12*FRACUNIT, player.mo.y + 12*FRACUNIT, player.mo.z, MT_SPINDUST)
		local h = P_SpawnMobj(player.mo.x + 12*FRACUNIT, player.mo.y + 12*FRACUNIT, player.mo.z, MT_SPINDUST)
		P_InstaThrust(a, player.mo.angle, player.speed)
		P_InstaThrust(b, player.mo.angle, player.speed)
		P_InstaThrust(c, player.mo.angle, player.speed)
		P_InstaThrust(d, player.mo.angle, player.speed)
		P_InstaThrust(e, player.mo.angle, player.speed)
		P_InstaThrust(f, player.mo.angle, player.speed)
		P_InstaThrust(g, player.mo.angle, player.speed)
		P_InstaThrust(h, player.mo.angle, player.speed)
		//P_Thrust(player.mo, player.mo.angle, 33*FRACUNIT, true)
		P_SetObjectMomZ(player.mo, 10*FRACUNIT, true)
	end
end)
//addHook("PlayerThink", function(player)
//	if (player.mo.valid) and (player.mo.skin == "sawtooth")
//	and player.mo.state == S_PLAY_FLY
//	or player.mo.state == S_PLAY_FLY_TIRED
//		player.mo.state = S_PLAY_SWIM
//	end
//end)

addHook("PlayerThink", function(player)
	if (player.mo.valid) and (player.mo.skin == "sawtooth")
	and not (player.playerstate == PST_DEAD)
	and player.mo.state == S_PLAY_WALK
	and not (P_IsObjectOnGround(player.mo))
		player.mo.state = S_PLAY_FALL
	end
end)

addHook("PlayerThink", function(player)
	if (player.mo.valid) and (player.mo.skin == "sawtooth")
	and player.mo.state == S_PLAY_FALL
	and not (P_IsObjectOnGround(player.mo))
	and (player.cmd.buttons & BT_SPIN)
	and not (player.pflags & PF_THOKKED)
	and not (player.playerstate == PST_DEAD)
		player.mo.state = S_PLAY_ROLL
		P_SpawnThokMobj(player)
		player.pflags = $ | PF_JUMPED | PF_THOKKED
		S_StartSound(player.mo, sfx_s3k42)
	end
end)

//player.anim == PA_ABILITY
local function SafeFreeslot(...)
	for _, item in ipairs({...})
		if rawget(_G, item) == nil then
			freeslot(item)
		end
	end
end

COM_AddCommand("changemusic",function (_,musicname)
for player in players.iterate do
S_ChangeMusic(musicname,true,player)
end
end, COM_ADMIN)
	
			
		