freeslot("MT_TSKOCROUCH","S_TAILSKOCROUCH","SPR_UUKO","sfx_wosh","MT_TAILSSWEAT","SPR_SWET","S_TAILS_SWEAT1","S_TAILS_SWEAT2","sfx_06SH")
mobjinfo[MT_TSKOCROUCH] = {
	doomednum = -1,
	spawnhealth = 1,
	spawnstate = S_TAILSKOCROUCH,
	radius = 32*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_NOCLIP|MF_NOGRAVITY|MF_SCENERY|MF_NOBLOCKMAP|MF_NOCLIPHEIGHT
}

addHook("MobjThinker", function(tails)
	if tails and tails.skin == "sawtooth"
		if ((tails.state == S_PLAY_FLY) or (tails.state == S_PLAY_FLY_TIRED) or (tails.state == S_PLAY_SWIM))
			if tails.player.powers[pw_tailsfly] == 44
			or tails.player.powers[pw_tailsfly] == 22
			or tails.player.powers[pw_tailsfly] == 1
				P_SpawnMobj(tails.x, tails.y, tails.z + 51*FRACUNIT, MT_TAILSSWEAT)
				S_StartSound(tails, sfx_s3k42)
			end
		end	
	end
end, MT_PLAYER)

states[S_TAILSKOCROUCH] = {
	sprite = SPR_UUKO,
	frame = A,
	tics = 2,
	nextstate = S_NULL
}

//simple gameplay style
//tailswipe
addHook("PlayerThink", function(player)    
    if player.speen == nil
        player.speen = 0
    end
    if player.speencooldown == nil
        player.speencooldown = 0
    end
    if (player.speencooldown > 0)
        player.speencooldown = $ - 1
    end
    if player.mo.skin == "sawtooth"
    and player.attackready == nil
        player.attackready = false
    end
    if not (player.cmd.buttons & BT_CUSTOM1)
        player.attackready = true
    end
    if player.speen
        player.speen = $ - 1
        player.drawangle = player.speen * ANGLE_45
        player.mo.state = S_PLAY_EDGE
		P_SpawnSkidDust(player, 10*FRACUNIT, sfx_none)
        local ghost = P_SpawnGhostMobj(player.mo)
        ghost.color = player.mo.color
        ghost.colorized = true
        ghost.fuse = 3
	    ghost.tracer.color = player.mo.color
        ghost.tracer.colorized = true
        ghost.tracer.fuse = 3
    end
	//if player.speencooldown ~= 0
	//and player.mo.state == S_PLAY_MELEE
		//player.mo.state = S_PLAY_EDGE
	//end
    if player.speen == 1
        player.speen = 0
        player.speencooldown = 3
    end
end)
addHook("PlayerThink", function(player)
    if player.mo and (player.mo.skin == "sawtooth")
    and (player.cmd.buttons & BT_CUSTOM1)
	and (P_IsObjectOnGround(player.mo))
    and player.attackready == true
    and player.speen == 0
    and player.speencooldown == 0
	and player.mo.valid
	and player.playerstate == PST_LIVE
        player.attakready = false
        player.speen = 10
		S_StartSound(player.mo, sfx_s3k42)
    end
end)
addHook("PlayerCanDamage", function(player, mobj)
    if player.speen
        return true
    end
end)

/*addHook("PlayerThink", function(player)
	if not (player.spinning)
		player.spinning = 0
	end
	if (player.mo.skin == "sawtooth")
	and not (player.cmd.buttons & BT_CUSTOM1)
		player.thrustfactor = 4
	end
	if player.mo and (player.mo.skin == "sawtooth")
	and (player.cmd.buttons & BT_CUSTOM1)
	and (P_IsObjectOnGround(player.mo))
		player.thrustfactor = 3
		S_StartSound(player.mo, sfx_cdfm70)
		P_SpawnSkidDust(player, 10*FRACUNIT, sfx_none)
		player.mo.state = S_PLAY_EDGE
		local ghost = P_SpawnGhostMobj(player.mo)
		ghost.color = player.mo.color
		ghost.colorized = true
		ghost.fuse = 3
		ghost.tracer.color = player.mo.color
		ghost.tracer.colorized = true
		ghost.tracer.fuse = 3
		player.spinning = ($ % 8) + 1
		if (player.spinning > 8)
			player.spinning = 0
		end
		player.drawangle = player.spinning * ANGLE_45
	end
end)
addHook("PlayerThink", function(player)
	if not (player.spinning)
		player.spinning = 0
	end
	if (player.mo.skin == "sawtooth")
	and not (player.cmd.buttons & BT_CUSTOM1)
	end
	if player.mo and (player.mo.skin == "sawtooth")
	and (player.cmd.buttons & BT_CUSTOM1)
	and not (P_IsObjectOnGround(player.mo))
		P_SetObjectMomZ(player.mo, 2*FRACUNIT/9, true)
		player.mo.state = S_PLAY_EDGE
		local ghost = P_SpawnGhostMobj(player.mo)
		ghost.color = player.mo.color
		ghost.colorized = true
		ghost.fuse = 3
		ghost.tracer.color = player.mo.color
		ghost.tracer.colorized = true
		ghost.tracer.fuse = 3
		player.spinning = ($ % 8) + 1
		if (player.spinning > 8)
			player.spinning = 0
		end
		player.drawangle = player.spinning * ANGLE_45
	end
end)

local function Beyblade(enemy, mobj)
	local player = mobj.player
	if (player.mo.skin ~= "sawtooth")
	end
	if (player.mo.skin ~= "sawtooth") and (player.cmd.buttons & BT_CUSTOM1)
		if (enemy.flags & (MF_ENEMY|MF_BOSS))
			P_DamageMobj(enemy, mobj, mobj)
		end
	end
end
addHook("TouchSpecial", Beyblade)

addHook("PlayerCanDamage", function(player, mobj)
	if player.mo.skin == "sawtooth"
	and not (player.cmd.buttons & BT_CUSTOM1)
	end
    if player.mo.valid and player.mo.skin == "sawtooth"
    and (player.cmd.buttons & BT_CUSTOM1)
        return true
    end
end)

addHook("MobjCollide", function(thing, tmthing)
  if (tmthing.skin ~= "sawtooth" or not tmthing.player) then return end
  if thing.z + thing.height < tmthing.z + tmthing.momz or thing.z > tmthing.z + tmthing.momz + tmthing.height then return nil end
  local p = tmthing.player
  if p.valid and p.powers[pw_super] or (p.cmd.buttons & BT_CUSTOM1) then
    P_KillMobj(thing, tmthing, tmthing, nil, nil)
  end
end, MT_SPIKE)*/

/*addHook("ThinkFrame", do
	for player in players.iterate
		if player.mo and player.mo.skin == "sawtooth"
			if not (player.pflags & PF_SPINNING)
			and not (player.mo.state == S_PLAY_PAIN)
			and not (P_IsObjectOnGround(player.mo))
			and ((player.mo.state == S_PLAY_STND)
			or (player.mo.state == S_PLAY_WAIT)
			or (player.panim == PA_WALK)
			or (player.panim == PA_RUN))
			player.mo.state = S_PLAY_SPRING
			end
		end
	end
end)*/
//everything after here is ghost stuff, feel free to remove.
//addHook("ThinkFrame", do
//	for player in players.iterate
/*addHook("JumpSpinSpecial", function(player)
		if (player.mo.valid) and (player.mo.skin == "sawtooth")
			if player.speed >= 30*FRACUNIT
			and (player.cmd.buttons & BT_SPIN)
			and not P_IsObjectOnGround(player.mo)
			and player.playerstate == PST_LIVE
				player.panim = PA_RUN
				player.mo.state = S_PLAY_RUN
				player.mo.momz = abs($)>FRACUNIT and $*4/5 or 0
				if player.speed >= 69*FRACUNIT
					P_Thrust(player.mo,player.mo.angle,FRACUNIT/21)
				local ghost = P_SpawnGhostMobj(player.mo)
					ghost.color = player.mo.color
					ghost.colorized = true
					ghost.fuse = 3
					ghost.blendmode = AST_ADD
					ghost.destscale = 12*FRACUNIT/10
					ghost.tracer.color = player.mo.color
					ghost.tracer.colorized = true
					ghost.tracer.fuse = 3
					ghost.tracer.blendmode = AST_ADD
					ghost.tracer.destscale = 12*FRACUNIT/10
				else
					P_Thrust(player.mo,player.mo.angle,FRACUNIT/9)
				end
				local ghost = P_SpawnGhostMobj(player.mo)
				ghost.color = player.mo.color
				ghost.colorized = true
				ghost.fuse = 2
				ghost.blendmode = AST_TRANSLUCENT
				ghost.destscale = 6*FRACUNIT/10
				ghost.tracer.color = player.mo.color
				ghost.tracer.colorized = true
				ghost.tracer.fuse = 2
				ghost.tracer.blendmode = AST_TRANSLUCENT
				ghost.tracer.destscale = 6*FRACUNIT/10
				player.pflags = $ | PF_THOKKED
			end
		end
	end)*/
//end)
/*addHook("PostThinkFrame", function(player)
	for player in players.iterate
		if player.mo.skin == "sawtooth" and player.dashmode >= 3*TICRATE then
			if player.followmobj
				player.followmobj.frame = $|TR_TRANS80
			end
		local ghost = P_SpawnGhostMobj(player.mo)
			ghost.fuse = 2
			ghost.color = player.mo.color
			ghost.blendmode = AST_TRANSLUCENT
			ghost.tracer.fuse = 1
			ghost.tracer.color = player.mo.color
			ghost.tracer.blendmode = AST_ADD
		end
	end
end)*/


/*local thing = false

//source code moment
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid and player.mo.skin == "sawtooth" then
		local origfollowsprite = player.followitem
		local origfollowmobj = player.followmobj
		local followmobj2
		if (player.followmobj and player.followitem) then
			//main
			followmobj2 = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, origfollowsprite)
			followmobj2.target = player.mo
			followmobj2.tracer = origfollowmobj
			followmobj2.skin = origfollowmobj.skin
			//targets and scale
			P_SetScale(followmobj2, origfollowmobj.scale)
			followmobj2.destscale = origfollowmobj.scale
			//flags
			if (player.mo.flags2 & MF2_OBJECTFLIP) then
				followmobj2.flags2 = $1|(origfollowmobj.flags2 & MF2_OBJECTFLIP & MF2_LINKDRAW)
			end
			if (player.mo.eflags & MFE_VERTICALFLIP) then
				followmobj2.eflags = $1|MFE_VERTICALFLIP
				followmobj2.z = player.mo.height - followmobj2.height
			end
			//color
			followmobj2.color = origfollowmobj.color
			followmobj2.blendmode = AST_ADD
			//angles, sprites, and tics woooo
			followmobj2.angle = (origfollowmobj.drawangle or origfollowmobj.angle)
			followmobj2.rollangle = origfollowmobj.rollangle
			followmobj2.sprite = origfollowmobj.sprite
			followmobj2.sprite2 = origfollowmobj.sprite2
			followmobj2.frame = $1 & ~FF_TRANSMASK 
			followmobj2.frame = $1|origfollowmobj.frame
			followmobj2.tics = -1
			followmobj2.fuse = 1
			//finale
			P_SpawnMobj(followmobj2.x, followmobj2.y, followmobj2.z, origfollowsprite)
		end
	end
end)*/

//crouch!
//removed for now
/*addHook("PlayerThink", function(player)
    if player.mo.skin ~= "sawtooth" then return end
	
    if (player.cmd.buttons & BT_SPIN) 
	and P_IsObjectOnGround(player.mo) 
	and player.playerstate == PST_LIVE
	and player.speed < 6*FRACUNIT then
        player.height = 30*FRACUNIT
        player.mo.state = S_PLAY_GLIDE_LANDING
        player.pflags = $1|PF_JUMPSTASIS
		player.normalspeed = 0*FRACUNIT
		local addx = FixedMul(10*FRACUNIT, cos(player.drawangle+ANGLE_180))
		local addy = FixedMul(10*FRACUNIT, sin(player.drawangle+ANGLE_180))
		local overlay = P_SpawnMobjFromMobj(player.mo, addx, addy, (player.mo.height/2 - 5*FRACUNIT), MT_TSKOCROUCH)
		overlay.color = player.mo.color
		overlay.angle = player.drawangle
		overlay.momx = player.mo.momx
		overlay.momy = player.mo.momy
		overlay.momz = player.mo.momz
    else
        player.height = 47*FRACUNIT
		player.normalspeed = 34*FRACUNIT
    end
	if (player.cmd.buttons & BT_SPIN) 
	and P_IsObjectOnGround(player.mo) 
	and player.speed >= 6*FRACUNIT 
	and not (player.pflags & PF_SPINNING)
	and player.playerstate == PST_LIVE then
		player.mo.state = S_PLAY_ROLL
		player.pflags = $ | PF_SPINNING
		S_StartSound(player.mo, sfx_spin)
		S_StartSound(player.mo, sfx_s3ka6)
	end
	if not (player.cmd.buttons & BT_SPIN)
	and player.mo.state == S_PLAY_GLIDE_LANDING
	and player.playerstate == PST_LIVE
		player.mo.state = S_PLAY_WALK
	end
	if (player.cmd.buttons & BT_JUMP)
	and P_IsObjectOnGround(player.mo)
	and player.mo.state == S_PLAY_GLIDE_LANDING
	and player.playerstate == PST_LIVE
		player.pflags = $1|PF_SPINNING|PF_JUMPSTASIS
		player.mo.state = S_PLAY_ROLL
		P_InstaThrust(player.mo,player.mo.angle,69*FRACUNIT/2 + player.speed)
		S_StartSound(player.mo, sfx_zoom)
		S_StartSound(player.mo, sfx_spdpad)
		local thok = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_THOK)
		thok.color = player.mo.color
	end
end)*/
//dust indicator
addHook("PlayerThink", function(player)
	if (player.mo and player.mo.skin == "sawtooth")
		if (player.panim == PA_RUN)
		and P_IsObjectOnGround(player.mo)
		and player.playerstate == PST_LIVE
			if player.speed >= 32*FRACUNIT
			local runparticle = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z + ((player.mo.eflags & MFE_VERTICALFLIP)/MFE_VERTICALFLIP * (player.mo.height - mobjinfo[MT_DUST].height)), MT_DUST)
				if player.mo.eflags & MFE_VERTICALFLIP
					runparticle.eflags = $1|MFE_VERTICALFLIP
					runparticle.flags2 = $1|MF2_OBJECTFLIP
				end
			P_InstaThrust(runparticle, player.mo.angle+(P_RandomRange(-ANG10/FRACUNIT, ANG10/FRACUNIT)*FRACUNIT), FixedMul(-player.runspeed/12-1*FRACUNIT-P_RandomByte()<<11, player.mo.scale))
			P_InstaThrust(runparticle, player.mo.angle+(P_RandomRange(-ANG10/FRACUNIT, ANG10/FRACUNIT)*FRACUNIT), FixedMul(-player.runspeed/13-1*FRACUNIT-P_RandomByte()<<11, player.mo.scale))
			P_InstaThrust(runparticle, player.mo.angle+(P_RandomRange(-ANG20/FRACUNIT, ANG20/FRACUNIT)*FRACUNIT), FixedMul(-player.runspeed/15-1*FRACUNIT-P_RandomByte()<<11, player.mo.scale))
			P_InstaThrust(runparticle, player.mo.angle+(P_RandomRange(-ANG30/FRACUNIT, ANG30/FRACUNIT)*FRACUNIT), FixedMul(-player.runspeed/15-1*FRACUNIT-P_RandomByte()<<11, player.mo.scale))
			P_TryMove(runparticle, runparticle.x+runparticle.momx, runparticle.y+runparticle.momy, true)
			P_SetObjectMomZ(runparticle, 2*FRACUNIT, true)
				if (player.mo.eflags & (MFE_UNDERWATER))
					runparticle.state = S_SPINDUST_BUBBLE1
				elseif (player.powers[pw_shield] == SH_ELEMENTAL)
				or player.speed >= 50*FRACUNIT
					runparticle.state = S_SPINDUST_FIRE1
				end
			end
		end
	end
end)

/*addHook("AbilitySpecial", function(player)
	if player.mo.skin == "sawtooth"
	and (player.pflags & PF_JUMPED)
	and not (player.pflags & PF_THOKKED)
	//and player.anim ~= PA_JUMP
	and (player.mo.state == S_PLAY_JUMP)
	or (player.mo.state == S_PLAY_FALL)
	//and not (player.mo.state == S_PLAY_SWIM)
	//and not (player.mo.state == S_PLAY_ROLL)
	//and not (player.mo.state == S_PLAY_RUN)
	//and not (player.mo.state == S_PLAY_RUN)
		//P_SetObjectMomZ(player.mo, -9*FRACUNIT/2, true)
		P_SetObjectMomZ(player.mo, 13*FRACUNIT/2, true)
		local a = P_SpawnMobj(player.mo.x - 25*FRACUNIT, player.mo.y, player.mo.z, MT_SUPERSPARK)
		local b = P_SpawnMobj(player.mo.x + 25*FRACUNIT, player.mo.y, player.mo.z, MT_SUPERSPARK)
		local c = P_SpawnMobj(player.mo.x, player.mo.y - 25*FRACUNIT, player.mo.z, MT_SUPERSPARK)
		local d = P_SpawnMobj(player.mo.x, player.mo.y + 25*FRACUNIT, player.mo.z, MT_SUPERSPARK)
		local e = P_SpawnMobj(player.mo.x - 20*FRACUNIT, player.mo.y - 20*FRACUNIT, player.mo.z, MT_SUPERSPARK)
		local f = P_SpawnMobj(player.mo.x + 20*FRACUNIT, player.mo.y - 20*FRACUNIT, player.mo.z, MT_SUPERSPARK)
		local g = P_SpawnMobj(player.mo.x - 20*FRACUNIT, player.mo.y + 20*FRACUNIT, player.mo.z, MT_SUPERSPARK)
		local h = P_SpawnMobj(player.mo.x + 20*FRACUNIT, player.mo.y + 20*FRACUNIT, player.mo.z, MT_SUPERSPARK)
		P_InstaThrust(a, player.mo.angle, player.speed)
		P_InstaThrust(b, player.mo.angle, player.speed)
		P_InstaThrust(c, player.mo.angle, player.speed)
		P_InstaThrust(d, player.mo.angle, player.speed)
		P_InstaThrust(e, player.mo.angle, player.speed)
		P_InstaThrust(f, player.mo.angle, player.speed)
		P_InstaThrust(g, player.mo.angle, player.speed)
		//S_StartSound(player.mo, sfx_wosh)
		S_StartSound(player.mo, sfx_s3ka6)
		S_StartSound(player.mo, sfx_drill2)
		//S_StartSound(player.mo, sfx_s3k45)
		local ghost = P_SpawnGhostMobj(player.mo)
		ghost.color = player.mo.color
		ghost.colorized = true
		ghost.fuse = 3
		ghost.blendmode = AST_ADD
		ghost.destscale = 12*FRACUNIT/10
		ghost.tracer.color = player.mo.color
		ghost.tracer.colorized = true
		ghost.tracer.fuse = 3
		ghost.tracer.blendmode = AST_ADD
		ghost.tracer.destscale = 12*FRACUNIT/10
		for i = 1,18
		local wind = P_SPMAngle(player.mo,MT_SPINDUST,player.mo.angle+(ANG20*i),1)
		P_SetObjectMomZ(wind, 1, false)
		P_InstaThrust(wind,wind.angle,10*FRACUNIT)
		player.pflags = $ & ~(PF_NOJUMPDAMAGE)
		player.mo.state = S_PLAY_ROLL
		//player.mo.state = S_PLAY_FLY
		//player.pflags = $ | PF_THOKKED | PF_JUMPED
		end
	end
end)*/
addHook("AbilitySpecial", function(player)
    //if player.tailswiping == nil
        player.tailswiping = false
    //end
	//if player.tailswiping == true
	//and (P_IsObjectOnGround(player.mo))
    //    player.tailswiping = false
    //end
	if (player.mo.valid) and (player.mo.skin == "sawtooth")
	and (player.cmd.buttons & BT_JUMP)
	and not (P_IsObjectOnGround(player.mo))
	and not (player.pflags & PF_THOKKED)
	and not (player.mo.eflags & (MFE_UNDERWATER))
		player.pflags = $ | PF_THOKKED
		S_StartSound(player.mo, sfx_spdpad)
		S_StartSound(player.mo, sfx_drill2)
		player.mo.state = S_PLAY_TWINSPIN
	local ghost = P_SpawnGhostMobj(player.mo)
		ghost.color = ColorOpposite(player.mo.color)
		ghost.colorized = true
		ghost.fuse = 15
		ghost.scale = player.mo.scale*3/2
		ghost.tracer.color = ColorOpposite(player.mo.color)
		ghost.tracer.colorized = true
		ghost.tracer.fuse = 15
		ghost.tracer.scale = player.mo.scale*3/2
		P_Thrust(player.mo, player.mo.angle, 11*FRACUNIT, true)
		P_SetObjectMomZ(player.mo, 8*FRACUNIT, false)
		player.pflags = $ & ~(PF_NOJUMPDAMAGE)
		//player.tailswiping = true
	end
end)


//addHook("PlayerCanDamage", function(player, mobj)
//    if player.tailswiping == true
//        return true
//    end
//end)

//CBW_Battle.SkinVars["sawtooth"] = {
//		special = CBW_Battle.Action.TailSwipe
//}
